/* Subroutines for ANSI terminal emulation */

#include <stdio.h>

void gotoxy(
int x,
int y)
{
	printf("\033[%i;%iH",x,y);
}

void savepos()
{
	printf("\033[s");
}

void restorepos()
{
	printf("\033[u");
}

void clrscr()
{
	printf("\033[2J");
}

void setback(
int c)
{
	printf("\033[%im",c+40);
}

void setfore(
int c)
{
	printf("\033[%im",c+30);
}

void setcolor(
int f,
int b)
{
	int fa;
	if (f>8) {
	   printf("\033[1m");
	   fa=f-8;
	} else {
 	   printf("\033[0m");
	   fa=f;
	}
	printf("\033[%im",30+fa);
	printf("\033[%im",40+b);
}

void resetcolor()
{
	printf("\033[0m");
}
