/* display.c - display status lines at top of screen - dg1kjd 20-4-95 */

#include "config.h"
#include "ansi.h"
#include <stdio.h>
#include "timer.h"
#include "main.h"
#include "global.h"
#include "ax25.h"
#include "lapb.h"
#include "ip.h"
#include "arp.h"
#include "session.h"

int logincnt;
int sescnt;

int axcbcnt()
{
	struct ax25_cb *axp = NULLAX25;
	int cnt;
	cnt=0;
	if (Ax25_cb) {
	   cnt++;
	   for(axp = Ax25_cb; axp->next != NULLAX25; axp=axp->next) cnt++;
	}    
	return(cnt);
}

int routecnt()
{
	struct route *rp = NULLROUTE;
	int cnt;
	int bits;
	int i;
	cnt=0;
	for(bits=31;bits>=0;bits--){
		for(i=0;i<HASHMOD;i++){
			for(rp = Routes[bits][i];rp != NULLROUTE;rp = rp->next){
				cnt++;
			}
		}
	}
	return(cnt);
}

int arpcnt()
{
	struct arp_tab *ap = NULLARP;
	int cnt;
	int i;
	cnt=0;
	for(i=0;i<HASHMOD;i++){
		for(ap = Arp_tab[i];ap != NULLARP;ap = ap->next) cnt++;
	}
	return(cnt);
}

void updstline1()
{
	setcolor(15,4);
	printf("%-15s",Version);
	setcolor(7,4);
	printf("  axcb: ");
	setcolor(15,4);
	printf("%2i",axcbcnt());  
	setcolor(7,4);
	printf("  logins: ");
	setcolor(15,4);
	printf("%2i",logincnt);  
	setcolor(7,4);
	printf("  axroute: ");
	setcolor(15,4);
	printf("%4i",axroutecnt-1);  
	setcolor(7,4);
	printf("  arp: ");
	setcolor(15,4);
	printf("%4i",arpcnt());  
	setcolor(7,4);
	printf("  route: ");
	setcolor(15,4);
	printf("%4i    ",routecnt());
	resetcolor();
}

void updaxcntlline()
{
	struct ax25_cb *axp = NULLAX25;
	char tmp[AXBUF];
	int cnt;
	
	cnt=0;
	gotoxy(2,1);
	setcolor(15,5);
	gotoxy(2,1);
	for(cnt=0;cnt<12;cnt++) {
	   if (cnt==0) axp=Ax25_cb;
	   else if (axp) axp=axp->next;
	   if (cnt==6) {
	      printf("  ");
	      gotoxy(3,1);
	   }
	   if (axp) {
	   	switch (axp->state) {
	   		case LAPB_SETUP: {
	   			setcolor(15,6);
	   			break;
	   		}
	   		case LAPB_CONNECTED: {
	   			setcolor(15,2);
	   			break;
	   		}
	   		case LAPB_DISCPENDING: {
	   			setcolor(15,1);
	   			break;
	   		}
	   		case LAPB_RECOVERY: {
	   			setcolor(15,7);
	   			break;
	   		}
	   	}
	   	switch (axp->type) {
	   		case TYPE_UNKNOWN: {
	   			printf("?");
	   			break;
	   		}
	   		case TYPE_NO_L3:{
	   			printf("T");
	   			break;
	   		}
	   		case TYPE_NETROM:{
	   			printf("N");
	   			break;
	   		}
	   		case TYPE_FLEXNET:{
	   			printf("F");
	   			break;
	   		}
	   		case TYPE_IP:{
	   			printf("I");
	   			break;
	   		}
	   	}	
	   	if (axp->incoming) printf("<");
	   	else printf(">");
	   	setcolor(15,5);
	   	printf("%-9s",pax25(tmp,axp->hdr.dest));
	   } else printf("             ");
	printf("  ");
	}	
   printf("  ");
}

void updsesline()
{
	int currno;
	int currexists;
	int activeno;
	char tmp[AXBUF];
	struct session *sp;
	struct ax25_cb *axp;
	currno=0;
	currexists=0;
	activeno=0;
	for(sp=Sessions; sp < &Sessions[Nsessions];sp++){
		if ((sp->type==AX25TNC) || (sp->type==NRSESSION)) {
			activeno++;
			if (Current==sp) {
				currno=(int)(sp - Sessions);
				currexists=1;
			}
		}
	}
	gotoxy(4,1);
	setcolor(7,4);
	printf("ses: ");
	setcolor(15,4);
	if (currexists) printf("%2i of %2i:",currno,activeno);
	else printf("-- of %2i",activeno);
	if (Current) {
	   if (Current->type==AX25TNC) {
		 printf(" %-9s",pax25(tmp,Current->cb.ax25->hdr.dest));
		 printf("  %-9s",Ax25states[Current->cb.ax25->state]);
		 setcolor(7,4);
		 printf("    Srtt: ");
		 setcolor(15,4);
		 printf("%-5i", Current->cb.ax25->srt);
		 setcolor(7,4);
		 printf("  RxQ: ");
		 setcolor(15,4);
		 printf("%-5i", len_p(Current->cb.ax25->rxq));
		 setcolor(7,4);
		 printf("  &cb: ");
		 setcolor(15,4);
		 printf("%-11lx", (long) Current->cb.ax25);
	   } else printf("%67s"," ");
	} else printf("%67s"," ");
}

void updstlines(void *p)
{
	savepos();
	gotoxy(1,1);
	updstline1();
	updaxcntlline();
	updsesline();
	resetcolor();
	restorepos();
	if (stlineupdinterval) {
		set_timer(&stlinetimer,stlineupdinterval);
		start_timer(&stlinetimer);
	}
}